// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.internal.taglib;

import javax.faces.application.Application;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import org.apache.commons.lang.StringUtils;
import org.apache.myfaces.tobago.component.UIGridLayout;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/** 
 * JSP Tag class, generated from template {@code tag1.2.stg} with class 
 * {@link org.apache.myfaces.tobago.internal.taglib.component.GridLayoutTagDeclaration}.
 */
public final class GridLayoutTag extends TobagoELTag {
  private static final Logger LOG = LoggerFactory.getLogger(GridLayoutTag.class);
  private javax.el.ValueExpression  rowOverflow;
  private javax.el.ValueExpression  markup;
  private javax.el.ValueExpression  marginLeft;
  private javax.el.ValueExpression  marginTop;
  private javax.el.ValueExpression  marginRight;
  private javax.el.ValueExpression  columns;
  private javax.el.ValueExpression  cellspacing;
  private javax.el.ValueExpression  rows;
  private javax.el.ValueExpression  marginBottom;
  private javax.el.ValueExpression  columnOverflow;
  private javax.el.ValueExpression  rowSpacing;
  private javax.el.ValueExpression  margin;
  private javax.el.ValueExpression  border;
  private javax.el.ValueExpression  columnSpacing;

  @Override
  public String getComponentType() {
    return UIGridLayout.COMPONENT_TYPE;
  }
  @Override
  public String getRendererType() {
    return "GridLayout";
  }

  @Override
  protected void setProperties(final UIComponent uiComponent) {
    super.setProperties(uiComponent);
    final UIGridLayout component = (UIGridLayout) uiComponent;
    final FacesContext context = FacesContext.getCurrentInstance();
    final Application application = context.getApplication();
    if (rowOverflow != null) {
      if (!rowOverflow.isLiteralText()) {
        component.setValueExpression("rowOverflow", rowOverflow);
      } else {
        component.setRowOverflow(Boolean.parseBoolean(rowOverflow.getExpressionString()));
      }
    }
    if (markup != null) {
      if (!markup.isLiteralText()) {
        component.setValueExpression("markup", markup);
      } else {
        component.setMarkup(org.apache.myfaces.tobago.context.Markup.valueOf(markup.getExpressionString()));
      }
    }
    if (marginLeft != null) {
      if (!marginLeft.isLiteralText()) {
        component.setValueExpression("marginLeft", marginLeft);
      } else {
        component.setMarginLeft(org.apache.myfaces.tobago.layout.Measure.valueOf(marginLeft.getExpressionString()));
      }
    }
    if (marginTop != null) {
      if (!marginTop.isLiteralText()) {
        component.setValueExpression("marginTop", marginTop);
      } else {
        component.setMarginTop(org.apache.myfaces.tobago.layout.Measure.valueOf(marginTop.getExpressionString()));
      }
    }
    if (marginRight != null) {
      if (!marginRight.isLiteralText()) {
        component.setValueExpression("marginRight", marginRight);
      } else {
        component.setMarginRight(org.apache.myfaces.tobago.layout.Measure.valueOf(marginRight.getExpressionString()));
      }
    }
    if (columns != null) {
      component.setValueExpression("columns", columns);
    }

    if (cellspacing != null) {
      if (!cellspacing.isLiteralText()) {
        component.setValueExpression("cellspacing", cellspacing);
      } else {
        component.setCellspacing(org.apache.myfaces.tobago.layout.Measure.valueOf(cellspacing.getExpressionString()));
      }
    }
    if (rows != null) {
      component.setValueExpression("rows", rows);
    }

    if (marginBottom != null) {
      if (!marginBottom.isLiteralText()) {
        component.setValueExpression("marginBottom", marginBottom);
      } else {
        component.setMarginBottom(org.apache.myfaces.tobago.layout.Measure.valueOf(marginBottom.getExpressionString()));
      }
    }
    if (columnOverflow != null) {
      if (!columnOverflow.isLiteralText()) {
        component.setValueExpression("columnOverflow", columnOverflow);
      } else {
        component.setColumnOverflow(Boolean.parseBoolean(columnOverflow.getExpressionString()));
      }
    }
    if (rowSpacing != null) {
      if (!rowSpacing.isLiteralText()) {
        component.setValueExpression("rowSpacing", rowSpacing);
      } else {
        component.setRowSpacing(org.apache.myfaces.tobago.layout.Measure.valueOf(rowSpacing.getExpressionString()));
      }
    }
    if (margin != null) {
      if (!margin.isLiteralText()) {
        component.setValueExpression("margin", margin);
      } else {
        component.setMargin(org.apache.myfaces.tobago.layout.Measure.valueOf(margin.getExpressionString()));
      }
    }
    if (border != null) {
      component.setValueExpression("border", border);
    }

    if (columnSpacing != null) {
      if (!columnSpacing.isLiteralText()) {
        component.setValueExpression("columnSpacing", columnSpacing);
      } else {
        component.setColumnSpacing(org.apache.myfaces.tobago.layout.Measure.valueOf(columnSpacing.getExpressionString()));
      }
    }
  }

  public javax.el.ValueExpression getRowOverflow() {
    return rowOverflow;
  }

  public void setRowOverflow(final javax.el.ValueExpression rowOverflow) {
    this.rowOverflow = rowOverflow;
  }

  public javax.el.ValueExpression getMarkup() {
    return markup;
  }

  public void setMarkup(final javax.el.ValueExpression markup) {
    this.markup = markup;
  }

  public javax.el.ValueExpression getMarginLeft() {
    return marginLeft;
  }

  public void setMarginLeft(final javax.el.ValueExpression marginLeft) {
    this.marginLeft = marginLeft;
  }

  public javax.el.ValueExpression getMarginTop() {
    return marginTop;
  }

  public void setMarginTop(final javax.el.ValueExpression marginTop) {
    this.marginTop = marginTop;
  }

  public javax.el.ValueExpression getMarginRight() {
    return marginRight;
  }

  public void setMarginRight(final javax.el.ValueExpression marginRight) {
    this.marginRight = marginRight;
  }

  public javax.el.ValueExpression getColumns() {
    return columns;
  }

  public void setColumns(final javax.el.ValueExpression columns) {
    this.columns = columns;
  }

  public javax.el.ValueExpression getCellspacing() {
    return cellspacing;
  }

  public void setCellspacing(final javax.el.ValueExpression cellspacing) {
    this.cellspacing = cellspacing;
  }

  public javax.el.ValueExpression getRows() {
    return rows;
  }

  public void setRows(final javax.el.ValueExpression rows) {
    this.rows = rows;
  }

  public javax.el.ValueExpression getMarginBottom() {
    return marginBottom;
  }

  public void setMarginBottom(final javax.el.ValueExpression marginBottom) {
    this.marginBottom = marginBottom;
  }

  public javax.el.ValueExpression getColumnOverflow() {
    return columnOverflow;
  }

  public void setColumnOverflow(final javax.el.ValueExpression columnOverflow) {
    this.columnOverflow = columnOverflow;
  }

  public javax.el.ValueExpression getRowSpacing() {
    return rowSpacing;
  }

  public void setRowSpacing(final javax.el.ValueExpression rowSpacing) {
    this.rowSpacing = rowSpacing;
  }

  public javax.el.ValueExpression getMargin() {
    return margin;
  }

  public void setMargin(final javax.el.ValueExpression margin) {
    this.margin = margin;
  }

  public javax.el.ValueExpression getBorder() {
    return border;
  }

  public void setBorder(final javax.el.ValueExpression border) {
    this.border = border;
  }

  public javax.el.ValueExpression getColumnSpacing() {
    return columnSpacing;
  }

  public void setColumnSpacing(final javax.el.ValueExpression columnSpacing) {
    this.columnSpacing = columnSpacing;
  }



  @Override
  public void release() {
    super.release();
    rowOverflow = null;
    markup = null;
    marginLeft = null;
    marginTop = null;
    marginRight = null;
    columns = null;
    cellspacing = null;
    rows = null;
    marginBottom = null;
    columnOverflow = null;
    rowSpacing = null;
    margin = null;
    border = null;
    columnSpacing = null;
  }
}